/**
 * ModServ IRC Services
 * Version 2009
 * Copyright (C) 2007, 2008 Christian Jurk <commx@commx.ws>
 * All rights reserved.
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation; either version 3 of the License,
 * or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __MS_VIRTUSER_H
#define __MS_VIRTUSER_H

#include <QList>
#include <MS_Dl.h>
#include <MS_Users.h>

class MVirtualUser {
  private:
    MModule *m_module;
    QString m_realName;
    
  public:
    MVirtualUser(const QString &strNick);
    ~MVirtualUser();
    unsigned int getFreeNumeric(void);
    void setModule(MModule *module);
    void setRealname(const QString &strRealname);
    const QString &realname(void);
    MModule *module(void);
    void create(void);
    void sendquit(void);
    void joinChannel(const QString &strChannel, const quint32 &flags);
    void leaveChannel(const QString &strChannel);
    MUser *user;
};

extern QList<MVirtualUser *> vuserList;

#endif /* __MS_VIRTUSER_H */
